chatcontrol/database/models.py
import datetime

import sqlalchemy

from . import Base
from .utils import UUID, get_uuid

__all__ = ["Signature"]


class Signature(Base):
	__tablename__ = "signatures"

	id = sqlalchemy.Column(
		UUID,
		primary_key=True,
		default=get_uuid
	)

	name = sqlalchemy.Column(
		sqlalchemy.String(64),
		nullable=False
	)
	surname = sqlalchemy.Column(
		sqlalchemy.String(64),
		nullable=False
	)
	
	city = sqlalchemy.Column(
		sqlalchemy.String(64),
		nullable=False
	)
	country = sqlalchemy.Column(
		sqlalchemy.String(3),
		nullable=True
	)
	
	email = sqlalchemy.Column(
		sqlalchemy.String(128),
		nullable=True
	)
	comment = sqlalchemy.Column(
		sqlalchemy.String(65536),
		nullable=True
	)

chatcontrol/__init__.py
import json
import logging
import os
import typing

import flask
import flask_babel
import flask_limiter
import sqlalchemy
import sqlalchemy.orm


__version__ = "1.0.0"


logging.basicConfig(
	format="[%(asctime)s] %(levelname)s in %(module)s: %(message)s",
	level=getattr(
		logging,
		os.environ.get(
			"LOGGING_LEVEL",
			"DEBUG"
		)
	)
)


def create_app() -> flask.Flask:
	"""Creates a :class:`Flask <flask.Flask>` app with basic settings already
	applied.

	Loads the config from the file located where the ``CONFIG_LOCATION``
	environment variable describes, or ``$current_working_directory/config.json``
	if it's not set.

	Registers all blueprints in :mod:`.views`.
	"""

	app = flask.Flask(__name__)

	with app.app_context():
		app.logger.info("Setting up app")

		app.logger.debug("Loading config file")

		with open(
			os.environ.get(
				"CONFIG_LOCATION",
				os.path.join(
					os.getcwd(),
					"config.json"
				)
			),
			"r",
			encoding="utf-8"
		) as f:
			app.config.update(
				json.loads(f.read())
			)

		app.logger.debug("Creating engine")

		database_url = os.environ["DATABASE_URL"]

		if database_url.startswith("postgres://"):
			database_url = database_url.replace("postgres://", "postgresql://")

		sa_engine = sqlalchemy.create_engine(database_url)

		app.sa_session_class = sqlalchemy.orm.scoped_session(
			sqlalchemy.orm.sessionmaker(
				bind=sa_engine
			)
		)

		app.logger.debug("Setting up extensions")

		babel = flask_babel.Babel(app)
		app.babel = babel

		app.limiter = flask_limiter.Limiter(
			app,
			key_func=lambda: flask.request.headers.get(
				"X-Forwarded-For",
				flask.request.remote_addr
			),
			default_limits=["300 per day", "100 per hour"]
		)

		@babel.localeselector
		def get_locale():
			# Documentation: https://python-babel.github.io/flask-babel/

			locale = flask.request.accept_languages.best_match(["cs", "en"])

			return (
				locale
				if locale is not None
				else "en"
			)

		@app.before_request
		def before_request() -> None:
			"""TODO: doc"""

			flask.g.sa_session = flask.current_app.sa_session_class()
			flask.g.locale = get_locale()

		@app.teardown_request
		def teardown_request(
			exception: typing.Union[None, Exception]
		) -> None:
			"""Attempts to commit :attr:`flask.g.sa_session` and rolls it back if
			any exception is raised during the process. The exception is then
			logged.

			:param exception: The exception that occurred in the prior request,
				if there was any.
			"""

			if "sa_session" in flask.g:
				# "Clean" the session
				try:
					flask.g.sa_session.commit()
				except Exception as commit_exception:
					flask.g.sa_session.rollback()

					flask.current_app.logger.error(
						"Exception %s raised during the request teardown session commit: %s",
						commit_exception.__class__.__name__,
						(
							commit_exception
							if hasattr(commit_exception, "__str__")
							else "no details"
						)
					)

				flask.current_app.sa_session_class.remove()

		from .views import web_blueprint

		for blueprint in (web_blueprint,):
			app.logger.debug(
				"Registering blueprint: %s",
				blueprint
			)

			app.register_blueprint(blueprint)

		@app.cli.command("reflect")
		def reflect() -> None:
			"""Reflects database models."""

			from .database import Base

			with app.sa_session_class() as sa_session:
				Base.metadata.create_all(bind=sa_engine)

		return app

chatcontrol/database/__init__.py
import sqlalchemy.orm

Base = sqlalchemy.orm.declarative_base()

from .utils import UUID, get_uuid
from .models import Signature

__all__ = [
	"Signature",
	"UUID",
	"get_uuid"
]

chatcontrol/views/__init__.py
from .web import web_blueprint


__all__ = ["web_blueprint"]

chatcontrol/views/web.py
import flask
import flask_wtf
import pycountry
import sqlalchemy
import wtforms

from .. import database


web_blueprint = flask.Blueprint(
	"web",
	__name__
)


class CountrySelectField(wtforms.SelectField):
	# https://gist.github.com/mekza/516f172278c328468ea0
	# Thanks to mekza!
	def __init__(self, *args, **kwargs):
		super(CountrySelectField, self).__init__(*args, **kwargs)
		
		self.choices = [
			(country.alpha_2, country.name)
			for country
			in pycountry.countries
		]


class SignatureForm(flask_wtf.FlaskForm):
	name = wtforms.StringField(
		validators=[
			wtforms.validators.InputRequired(),
			wtforms.validators.Length(max=64)
		]
	)
	surname = wtforms.StringField(
		validators=[
			wtforms.validators.InputRequired(),
			wtforms.validators.Length(max=64)
		]
	)
	
	city = wtforms.StringField(
		validators=[
			wtforms.validators.InputRequired(),
			wtforms.validators.Length(max=64)
		]
	)
	country = CountrySelectField(
		validators=[
			wtforms.validators.Length(max=3)
		]
	)
	
	email = wtforms.EmailField(
		validators=[wtforms.validators.Length(max=128)]
	)
	comment = wtforms.TextAreaField(
		validators=[wtforms.validators.Length(max=65536)]
	)


@web_blueprint.route("/", methods=["GET"])
def view_index():
	return flask.render_template("index.html", is_article=True)


@web_blueprint.route("/materials", methods=["GET"])
def view_materials():
	return flask.render_template("materials.html", is_article=False)

@web_blueprint.route("/petition", methods=["GET", "POST"])
@flask.current_app.limiter.limit(
	"29/day",
	exempt_when=lambda: flask.request.method != "POST"
)
def view_petition():
	form = SignatureForm()
	
	added = False
	
	if flask.request.method == "POST" and form.validate_on_submit():
		signature = database.Signature(
			name=form.name.data,
			surname=form.surname.data,
			city=form.city.data,
			country=form.country.data,
			email=form.email.data,
			comment=form.comment.data
		)
		
		flask.g.sa_session.add(signature)
		flask.g.sa_session.commit()
		
		added = True
		
	signature_count = flask.g.sa_session.execute(
		sqlalchemy.select(sqlalchemy.func.count(database.Signature.id))
	).scalars().one()
	
	return flask.render_template(
		"petition.html",
		form=form,
		added=added,
		signature_count=signature_count,
		is_article=False
	)


@web_blueprint.route("/gdpr", methods=["GET"])
def view_gdpr():
	return flask.render_template("gdpr.html", is_article=False)

chatcontrol/templates/gdpr.html
{% extends 'base.html' %}

{% block description %}{{ gettext("Zapoj se do boje proti plošnému sledování zpráv podpisem petice. Tady jsou informace o tom, jak používám tvoje osobní údaje po podpisu.") }}{% endblock %}

{% block title %}{{ gettext("ChatControl - Ochrana osobních údajů petice") }}{% endblock %}

{% block header %}
	{{ gettext("Ochrana osobních údajů.")|safe }}
{% endblock %}

{% block main %}
	<p>
		{{ gettext("Osobní údaje v rozsahu, v jakém je vepisuješ do online petice sbírám pouze za účelem jejich předání adresátům petice, nevyužívám je pro žádné jiné účely a nesmí tak ze zákona činit ani adresáti petice. Pro petici jsem zhotovil vlastní stránku, takže vepisované osobní údaje se nedostanou k žádným třetím stranám. Pro předání petice pouze pořídím výtisk online podpisových archů, které uchovám po dobu pro vyřízení a archivaci petice u jejích adresátů, abych měl případně k prokázání penzum podpisů. Pak je skartuji a smažu původní databázi podpisů nasbíraných online.")|safe }}
	</p>
	
	<p>
		{{ gettext("V případě dotazů a žádostí (například dotazů na rozsah a podobu svých osobních údajů, odvolání souhlasu s podpisem petice, žádost o opravu či aktualizaci osobních údajů - tedy využití tvých zákonných práv) či námitek ohledně zpracování osobních údajů se na mne obrať: <a href='mailto:chatcontrol@imaniti.org'>chatcontrol@imaniti.org</a>. Také máš právo obrátit se na Úřad na ochranu osobních údajů (<a href='https://www.uoou.cz' target='_blank' rel='nofollow noreferrer noopener'>www.uoou.cz</a>), pokud by způsob zpracování osobních údajů dle tvého názoru nebyl v pořádku. Dávám ale na minimalizaci množství zpracovaných osobních údajů, jejich bezpečnost a správné zacházení velký pozor.")|safe }}
	</p>
	
	<p>
		{{ gettext("Děkuji, že jsi svým podpisem pomohl dlouhotrvajícímu boji proti plošnému sledování. Vážím si toho.")|safe }}
	</p>
	
	<p>
		{{ gettext("Tomáš Valenta, iniciátor petice a správce osobních údajů")|safe }}
	</p>
	
	<div class="back-wrapper">
		<img
			src="{{ url_for('static', filename='images/back.svg') }}"
			width="30"
			height"30"
		>
		<a href="{{ url_for('web.view_index') }}">
			{{ gettext("Zpět na hlavní stránku") }}
		</a>
	</div>
{% endblock %}

{% block footer %}
	<p>
		{{ gettext("Logo - kombinace clipartů od <a href='https://openclipart.org/detail/308328/love-chat-icon-bw' rel='nofollow noreferrer noopener' target='_blank'>GDJ</a> @ OpenClipart.")|safe }}
		
		<br>
		
		{{ gettext("Šipka zpět - <a href='https://openclipart.org/detail/26744/aiga-left-arrow-bg' rel='nofollow noreferrer noopener' target='_blank'>jean_victor_balin</a> @ OpenClipart.")|safe }}
	</p>
{% endblock %}

chatcontrol/templates/petition.html
{% extends 'base.html' %}

{% block description %}{{ gettext("Zapoj se do boje proti plošnému sledování zpráv podpisem petice.") }}{% endblock %}

{% block title %}{{ gettext("ChatControl - Petice") }}{% endblock %}

{% block header %}
	{{ gettext("Petice.")|safe }}
{% endblock %}

{% block main %}
	<section>
		<p id="counter">
			{{
				gettext("Momentálně máme <b>{} podpisů</b>.").
				format(signature_count)
				|safe
			}}<br>
			{% if added %}
				{{ gettext("<b>Za ten tvůj moc děkujeme!</b> A budeme ještě radši, pokud o nás řekneš někomu dalšímu.")|safe }}
			{% else %}
				{{ gettext("<b>Potřebujeme jich nasbírat co nejvíc, staň se autorem jenoho z nich!</b>")|safe }}
			{% endif %}
		</p>
	</section>
	
	<hr>
	
	<section>
		<p>{{ gettext("Vážení europoslanci,")|safe }}</p>
		
		<p>
			{{ gettext("Před dvěma roky byl v Evropské komisi představen prozatímní <a href='https://www.europarl.europa.eu/RegData/docs_autres_institutions/commission_europeenne/com/2020/0568/COM_COM(2020)0568_CS.pdf' target='_blank' rel='nofollow noreferrer noopener'>zákon</a>, který by poskytovatelům komunikačních služeb povoloval plošnou kontrolu zpráv jejich uživatelů pro odhalování distribuce dětské pornografie. Pokud jsou obrázek či zpráva vyhodnoceny jako podezřelé, jejich obsah je následně sdílen se zaměstnanci a policií pro další vyšetřování.")|safe }}
		</p>
		
		<p>
			{{ gettext("5. července 2021 byl přes značný odpor tento zákon, přezdívaný <i>ChatControl</i>, s dobou platnosti tří let <a href='https://mepwatch.eu/9/vote.html?v=134463&amp;country=cz&amp;eugroup=' target='_blank' rel='nofollow noreferrer noopener'>velkou</a> většinou <a href='https://eur-lex.europa.eu/legal-content/CS/TXT/?uri=CELEX%%3A32021R1232' target='_blank' rel='nofollow noreferrer noopener'>přijat</a>.")|safe }}
		</p>
		
		<p>
			{{ gettext("Po téměř roce interní diskuze byl 11. května 2022 představen nový <a href='https://eur-lex.europa.eu/legal-content/CS/TXT/?qid=1652451192472&amp;uri=COM%%3A2022%%3A209%%3AFIN' target='_blank' rel='nofollow noreferrer noopener'>návrh</a> tentokrát permanentního zákona, který by tuto praktiku učinil <b>povinnou pro všechny zprávy, videa, obrázky, emaily, hlasové hovory, soukromá cloudová úložiště jako iCloud či Google Drive i videohovory</b>.")|safe }}
		</p>
		
		<br>
		
		<p>
			{{ gettext("Ochrana dětí a jejich práv je velice důležitá. Přes dobrý úmysl návrhu ale může, stejně jako kdyby pošťák bez soudního nařízení otevíral všechny dopisy, mít fatální následky;")|safe }}
		</p>
		
		<ul>
			<li>
				<p>
					{{ gettext("<b>Soukromí digitální komunikace by bylo prakticky zrušeno.</b> Obsah komunikace absolutní většiny občanů EU - včetně novinářů, aktivistů a whistleblowerů - by byl automaticky a plošně analyzován. Nedávná kauza programu <a href='https://cs.wikipedia.org/wiki/Pegasus_(spyware)' target='_blank' rel='nofollow noreferrer noopener'>Pegasus</a> ukázala, že zájem o takové informace má leckdo, v EU například <a href='https://www.dw.com/en/german-police-secretly-bought-nso-pegasus-spyware/a-59113197' target='_blank' rel='nofollow noreferrer noopener'>německá policie</a>, <a href='https://www.dw.com/en/hungary-admits-to-using-nso-groups-pegasus-spyware/a-59726217' target='_blank' rel='nofollow noreferrer noopener'>vláda Viktora Orbána</a> a <a href='https://www.independent.co.uk/news/world/europe/poland-israel-nso-spyware-pegasus-b1988603.html' target='_blank' rel='nofollow noreferrer noopener' >polská PiS</a>. Zaměstnanci americké NSA zase už v roce 2013 zneužívali svého přístupu k informacím pro prohlížení a sdílení <a href='https://www.nytimes.com/2014/07/21/us/politics/edward-snowden-at-nsa-sexually-explicit-photos-often-shared.html?_r=0' target='_blank' rel='nofollow noreferrer noopener' >nahých fotek</a> cizích lidí, pravděpodobně i známých.")|safe }}
				</p>
				
				<p>
					{{ gettext("Narozdíl od již přijatého prozatímního zákona tento návrh zahrnuje i bezpečně šifrované platformy jako Telegram a Signal. Tyto služby by měly povinnost kontrolovat zprávy na zařízení uživatele a z něj odesílat hlášení, nebo prolomit své jinak bezpečné šifrování. První možnost by vedla k zařízení špehující na svého uživatele mimo jeho kontrolu, druhá k ekvivalentu zpráv, které nejsou šifrovány vůbec.")|safe }}
				</p>
				
				<p>
					{{ gettext("<a href='https://www.patrick-breyer.de/wp-content/uploads/2021/03/Legal-Opinion-Screening-for-child-pornography-2021-03-04.pdf' target='_blank' rel='nofollow noreferrer noopener'>Právní názory</a> navíc ukázaly, že plošná analýza komunikace bez jakéhokoliv důvodného podezření je neslučitelná s <a href='https://eur-lex.europa.eu/legal-content/CS/TXT/PDF/?uri=CELEX:12012P/TXT' target='_blank' rel='nofollow noreferrer noopener' >Listinou základních práv EU</a>.")|safe }}
				<p>
			</li>
			<li>
				<p>
					{{ gettext("<b>Anonymita na Internetu by se stala prakticky nemožnou.</b> Na roušce anonymity však kvůli své ochraně závisí spousta lidí, u kterých by informace o jejich identitě mohla znamenat jistou smrt, nebo v lepším případě absolutní vyloučení ze společnosti. Dle návrhu by ale běžné komunikační služby měly povinnost ověřit věk - a tedy i identitu - svých uživatelů.")|safe }}
				</p>
			</li>
			<li>
				<p>
					{{ gettext("<b>Soukromé soubory by byly bez podezření prohledávány.</b> Cloudové služby jako Google Drive, iCloud a OneDrive by měly povinnost kontrolovat a případně nahlašovat soubory svých zákazníků, i pokud je s nikým nesdíleli.")|safe }}
				</p>
			</li>
			<li>
				<p>
					{{ gettext("<b>Mnoho hlášení je mylných, ale přesto může vést k následkům.</b> Umělá inteligence a jiné systémy určené na ropoznávání nelegálního obsahu vytváří vysoká množství mylných hlášení, které přinejmenším přetěžují vyšetřovatele a odvádí pozornost od skutečných zločinců. Podle švýcarské policie je až <a href='https://fedpol.report/en/fedpol-in-figures/fight-against-paedophile-crime' target='_blank' rel='nofollow noreferrer noopener'>86%%</a> takových hlášení irelevantních. S policií mohou být sdíleny například fotky miminek a dětí na dovolené, nebo <a href='https://cs.wikipedia.org/wiki/Sexting' target='_blank' rel='nofollow noreferrer noopener'>sexting</a> mladých lidí. Tito mladí lidé pak mohou být mylně trestně stíháni, podle německých statistik je přes <a href='https://www.bka.de/EN/CurrentInformation/PoliceCrimeStatistics/policecrimestatistics_node.html' target='_blank' rel='nofollow noreferrer noopener'>33%%</a> takových trestních řízení zaměřeno na děti.")|safe }}
				</p>
			</li>
			<li>
				<p>
					{{ gettext("<b>Zločinci už dávno využívají bezpečnou komunikaci mimo vliv EU.</b> Ať je provozují sami nebo využívají mimoevropské služby, zločinci a technologicky zdatní občané vždy budou mít způsoby kontaktu s ostatními mimo oči velkého bratra. Běžní lidé, které by tento zákon nejvíc ovlivnil, však ne.")|safe }}
				</p>
				
				<p>
					{{ gettext("Velká část dětské pornografie není sdílena vůbec a zůstane na úložišti pachatele. Ta, která se na Internet dostane, nemá původ v běžných zprávách, ale například na uzavřených fórech, kde jsou soubory šifrovány heslem známým jen několika lidem. Může trvat roky, než se dostane do oběhu a detekční program má první šanci ji rozpoznat. Informace o původu jsou v tu chvíli dlouho pryč.")|safe }}
				</p>
			</li>
		</ul>
		
		<br>
		
		<p>{{ gettext("Jiné způsoby bojování s problémem však jsou. V první řadě musí být proporcionální k jeho řešení - což kontrolování milionů zpráv pro nalezení několika nelegálních není:") }}</p>
		
		<ul>
			<li>
				<p>
					{{ gettext("<b>Vzdělávání veřejnosti a pomoc (potenciálním) obětem.</b> Zejména v případě online zneužívání spousta dětí neví, jak se zachovat, nebo ho dokonce rozpoznat. Je <a href='https://ecpat.org/wp-content/uploads/2022/01/05-01-2022_Project-Report_EN_FINAL.pdf' target='_blank' rel='nofollow noreferrer noopener'>důležité</a> je informovat o bezpečném používání Internetu, možných způsobech nahlašování obsahu a existenci profesionální pomoci - v Česku například Linky Bezpečí. Například právě v chatovacích aplikacích, které používají.")|safe }}
				</p>
			</li>
			
			<li>
				<p>
					{{ gettext("<b>Společenské změny.</b> <a href='https://www.ciase.fr/rapport-final/' target='_blank' rel='nofollow noreferrer noopener'>Mnoho</a> <a href='https://www.who.int/publications/i/item/inspire-seven-strategies-for-ending-violence-against-children' target='_blank' rel='nofollow noreferrer noopener'>organizací</a> zdůrazňuje důležitost peněžních i časových investic například do odborů ochraňujících děti, škol a boje s chudobou.")|safe }}
				</p>
			</li>
			
			<li>
				<p>
					{{ gettext("<b>Reforma policie a dalších institucí.</b> Jedna z největších německých stránek s dětskou pornografií zůstala dostupná spoustu let, místní policie dle své vlastní zprávy na její odstranění neměla dostatek pracovní síly. Nezávislým novinářům, kteří stránku vyšetřovali, to <a href='https://netzpolitik.org/2022/depictions-of-child-abuse-the-internet-forgets-nothing-as-long-as-its-not-supposed-to-forget/' target='_blank' rel='nofollow noreferrer noopener'>trvalo několik dní</a>. S podobnými problémy se potýká i spousta ostatních členských států.")|safe }}
				</p>
			</li>
			
			{% if g.locale == "en" %}
				<li>
					<p>
						<b>Increasing both EU and national funding to hotlines</b>, ensuring a proper legal basis for their work, and committing funding further in advance. This would boost the capacity and reduce the precariousness of these vital organisations who already remove vast amounts of CSAM from the Internet quickly and effectively, and also provide support to survivors.
					</p>
				</li>
			{% endif %}
			
			<li>
				<p>
					{{ gettext("<b>Vymáhání existujících zákonů.</b> Evropská směrnice o zneužívání dětí z roku 2011 obsahuje řadu ustanovení, která členským státům ukládají povinnost se na vnitrostátní úrovni více zabývat sexuálním zneužíváním dětí. Nicméně i 11 let po jejím přijetí <a href='https://ec.europa.eu/commission/presscorner/detail/cs/inf_22_3768' target='_blank' rel='nofollow noreferrer noopener'>není stále plně zavedená</a>. Nově přijatý akt o digitálních službách také přináší další způsoby boje se zneužíváním dětí.")|safe }}
				</p>
			</li>
			
			<li>
				<p>
					{{ gettext("<b>Prevence.</b> Bez boje s jeho samotnými příčinami zneužívání dětí <a href='https://home.crin.org/issues/sexual-violence' rel='nofollow noopener noreferrer' target='_blank'>nelze zastavit</a>. Účinné strategie založené na prokázaných datech <a href='https://www.cdc.gov/violenceprevention/childsexualabuse/fastfact.html' target='_blank' rel='nofollow noreferrer noopener'>existují, ale široce z nich zatím bylo využito jen velmi málo</a>.")|safe }}
				</p>
			</li>
		</ul>
		
		<a
			href="https://edri.org/wp-content/uploads/2022/10/EDRi-Position-Paper-CSAR.pdf"
			target="_blank"
			rel="nofollow noopener noreferrer"
		><b>{{ gettext("Rozsáhlý dokument o alternativách publikovaný EDRi")|safe }}</b></a>
		|
		<a
			href="https://stopscanningme.eu/en/paper.html"
			target="_blank"
			rel="nofollow noopener noreferrer"
		>{{ gettext("Bližší informace a zdroje")|safe }}</a>
		
		<br><br>
		
		<p>{{ gettext("Tímto vás tedy my, níže podepsaní, žádáme, abyste se postavili za základní občanská práva i ve světě Internetu a udělali vše možné pro to, aby byl návrh zamítnut.") }}</p>
		
		<p>{{ gettext("Děkujeme.") }}</p>
	</section>
	
	<hr>
	
	<h2>{{ gettext("Podepsat") }}</h2>
	
	<form method="post">
		{{ form.csrf_token }}
		
		{{ form.name(placeholder=gettext("Jméno"), autocomplete="off", value="") }}
		{{ form.surname(placeholder=gettext("Příjmení"), autocomplete="off", value="") }}
		
		{{ form.city(placeholder=gettext("Město"), autocomplete="off", value="") }}
		
		{% if g.locale != "cs" %}
			{{ form.country(placeholder=gettext("Země"), autocomplete="off", value="") }}
		{% endif %}
		
		{{ form.email(placeholder=gettext("E-mail (nepovinný)"), autocomplete="off", value="") }}
		{{ form.comment(placeholder=gettext("Komentář (nepovinný)"), autocomplete="off", value="") }}
		
		<input type="submit" value="{{ gettext("Odeslat podpis!") }}">
		
		<br><br>
		
		<a href="{{ url_for('web.view_gdpr') }}">{{ gettext("Celé znění ochrany osobních údajů") }}</a>
		
		<br>&nbsp;
	</form>
	<div class="back-wrapper">
		<img
			src="{{ url_for('static', filename='images/back.svg') }}"
			width="30"
			height"30"
		>
		<a href="{{ url_for('web.view_index') }}">
			{{ gettext("Zpět na hlavní stránku") }}
		</a>
	</div>
{% endblock %}

{% block footer %}
	<p>
		{{ gettext("Logo - kombinace clipartů od <a href='https://openclipart.org/detail/308328/love-chat-icon-bw' rel='nofollow noreferrer noopener' target='_blank'>GDJ</a> @ OpenClipart.")|safe }}
		
		<br>
		
		{{ gettext("Šipka zpět - <a href='https://openclipart.org/detail/26744/aiga-left-arrow-bg' rel='nofollow noreferrer noopener' target='_blank'>jean_victor_balin</a> @ OpenClipart.")|safe }}
	</p>
{% endblock %}